Add sources.list support for squeeze-lts
[grml-debootstrap.git] / chroot-script
index f221d50..289773b 100755 (executable)
@@ -5,8 +5,9 @@
 # Bug-Reports:   see http://grml.org/bugs/
 # License:       This file is licensed under the GPL v2.
 ################################################################################
-
-set -e # exit on any error
+# GRML_CHROOT_SCRIPT_MARKER - do not remove this line unless you want to keep
+# this script as /bin/chroot-script on your new installed system
+################################################################################
 
 . /etc/debootstrap/config    || exit 1
 . /etc/debootstrap/variables || exit 1
@@ -17,11 +18,19 @@ set -e # exit on any error
 
 # use aptitude only if it's available
 if [ -x /usr/bin/aptitude ] ; then
-   APTINSTALL='aptitude -y --without-recommends install '
-   APTUPDATE='aptitude update'
+   APTUPDATE="aptitude update $DPKG_OPTIONS"
+   # Debian ISOs do not contain signed Release files
+   if [ -n "$ISO" ] ; then
+      APTINSTALL="aptitude -y --allow-untrusted --without-recommends install $DPKG_OPTIONS"
+      APTUPGRADE="aptitude -y --allow-untrusted safe-upgrade $DPKG_OPTIONS"
+   else
+      APTINSTALL="aptitude -y --without-recommends install $DPKG_OPTIONS"
+      APTUPGRADE="aptitude -y safe-upgrade $DPKG_OPTIONS"
+   fi
 else
-   APTINSTALL='apt-get --force-yes -y install'
-   APTUPDATE='apt-get update'
+   APTINSTALL="apt-get --force-yes -y --no-install-recommends install $DPKG_OPTIONS"
+   APTUPDATE="apt-get update $DPKG_OPTIONS"
+   APTUPGRADE="apt-get --force-yes -y upgrade $DPKG_OPTIONS"
 fi
 
 if [ -z "$STAGES" ] ; then
@@ -36,20 +45,86 @@ stage() {
      echo "$2" > "$STAGES/$1"
      return 0
   elif grep -q done "$STAGES/$1" 2>/dev/null ; then
-     echo "[*] Notice: stage $1 has been executed already, skipping execution therefore.">&2
+     echo "   [*] Notice: stage $1 has been executed already, skipping execution therefore.">&2
      return 1
   fi
+  echo "   Executing stage ${1}"
+  return 0
+}
+
+askpass() {
+  # read -s emulation for dash. result is in $resp.
+  set -o noglob
+  [ -t 0 ] && stty -echo
+  read resp
+  [ -t 0 ] && stty echo
+  set +o noglob
 }
 # }}}
 
 # define chroot mirror {{{
 chrootmirror() {
+  if [ -n "$KEEP_SRC_LIST" ] ; then
+    echo "KEEP_SRC_LIST has been set, skipping chrootmirror stage."
+    return
+  fi
+
+  if [ -z "$COMPONENTS" ] ; then
+    COMPONENTS='main contrib non-free'
+  fi
+  echo "Using repository components $COMPONENTS"
+
   if [ -n "$ISO" ] ; then
-     echo "deb $ISO $RELEASE main contrib" > /etc/apt/sources.list
-     [ -n "$CHROOTMIRROR" ] && echo "deb $CHROOTMIRROR $RELEASE main contrib non-free" >> /etc/apt/sources.list
+    echo "Adjusting sources.list for ISO (${ISO})."
+    echo "deb $ISO $RELEASE $COMPONENTS" > /etc/apt/sources.list
+    echo "Adding mirror entry (${MIRROR}) to sources.list."
+    [ -n "$MIRROR" ] && echo "deb $MIRROR $RELEASE $COMPONENTS" >> /etc/apt/sources.list || true
   else
-    if [ -n "$CHROOTMIRROR" ] ; then
-       echo "deb $CHROOTMIRROR $RELEASE main contrib non-free" > /etc/apt/sources.list
+    if [ -n "$MIRROR" ] ; then
+      echo "Adjusting sources.list for mirror (${MIRROR})."
+      echo "deb $MIRROR $RELEASE $COMPONENTS" > /etc/apt/sources.list
+    fi
+  fi
+
+  # LTS support
+  case "$RELEASE" in
+    squeeze)
+      if [ -n "$MIRROR" ] ; then
+        echo "Release matching $RELEASE - enabling LTS support in sources.list"
+        echo "deb $MIRROR ${RELEASE}-lts $COMPONENTS" >> /etc/apt/sources.list
+      fi
+      ;;
+  esac
+
+  # add security.debian.org:
+  case "$RELEASE" in
+    unstable|sid|lenny) ;;  # no security pool available
+    *)
+      echo "Adding security.debian.org to sources.list."
+      echo "deb http://security.debian.org ${RELEASE}/updates $COMPONENTS" >> /etc/apt/sources.list
+      ;;
+  esac
+}
+# }}}
+
+# remove local chroot mirror {{{
+remove_chrootmirror() {
+  if [ -n "$KEEP_SRC_LIST" ] ; then
+    echo "KEEP_SRC_LIST has been set, skipping remove_chrootmirror stage."
+    return
+  fi
+
+  if [ -n "$ISO" ] ; then
+    echo "Removing ISO (${ISO}) from sources.list."
+    TMP_ISO=$(echo "$ISO" |sed 's#/#\\/#g')
+    sed -i "/deb $TMP_ISO $RELEASE $COMPONENTS/ D" /etc/apt/sources.list
+  else
+    if [ -n "$MIRROR" -a -n "$(echo $MIRROR|grep file:)" ] ; then
+      echo "Removing local mirror (${MIRROR}) from sources.list."
+      TMP_MIRROR=$(echo "$MIRROR" |sed 's#/#\\/#g')
+      sed -i "/deb $TMP_MIRROR $RELEASE $COMPONENTS/ D" /etc/apt/sources.list
+      echo "Adding fallback mirror entry (${FALLBACK_MIRROR}) to sources.list instead."
+      echo "deb $FALLBACK_MIRROR $RELEASE $COMPONENTS" >> /etc/apt/sources.list
     fi
   fi
 }
@@ -58,8 +133,9 @@ chrootmirror() {
 # set up grml repository {{{
 grmlrepos() {
   if [ -n "$GRMLREPOS" ] ; then
-     cat >> /etc/apt/sources.list << EOF
-
+     # user might have provided their own apt sources.list
+     if ! grep -q grml /etc/apt/sources.list.d/grml.list 2>/dev/null ; then
+        cat >> /etc/apt/sources.list.d/grml.list << EOF
 # grml: stable repository:
   deb     http://deb.grml.org/ grml-stable  main
   deb-src http://deb.grml.org/ grml-stable  main
@@ -67,14 +143,20 @@ grmlrepos() {
 # grml: testing/development repository:
   deb     http://deb.grml.org/ grml-testing main
   deb-src http://deb.grml.org/ grml-testing main
-
 EOF
-     # make sure we have the keys available for aptitude
-     gpg --keyserver subkeys.pgp.net --recv-keys F61E2E7CECDEA787
-     gpg --export F61E2E7CECDEA787 | apt-key add - || /bin/true # not yet sure
-     # why it's necessary, sometimes we get an error even though it works [mika]
+     fi
+
+     if apt-get update $DPKG_OPTIONS; then
+       apt-get -y --allow-unauthenticated install grml-debian-keyring $DPKG_OPTIONS
+       apt-get update $DPKG_OPTIONS
+     else
+       # make sure we have the keys available for aptitude
+       gpg --keyserver subkeys.pgp.net --recv-keys F61E2E7CECDEA787
+       gpg --export F61E2E7CECDEA787 | apt-key add - || true # not yet sure
+       # why it's necessary, sometimes we get an error even though it works [mika]
+     fi
 
-     # make sure we install packages from grml's pool only if not available
+     # make sure we install packages from Grml's pool only if not available
      # from Debian!
      if ! grep -q grml /etc/apt/preferences 2>/dev/null ; then
         cat >> /etc/apt/preferences << EOF
@@ -93,6 +175,32 @@ EOF
 }
 # }}}
 
+# check available backports release version {{{
+checkbackports() {
+  wget -q -O/dev/null http://backports.debian.org/debian-backports/dists/${1}-backports/Release
+}
+# }}}
+
+# feature to provide Debian backports repos {{{
+backportrepos() {
+    if [ -n "$BACKPORTREPOS" ] ; then
+        if ! checkbackports $RELEASE ; then
+            echo "Backports for ${RELEASE} are not available." >&2
+            exit 1
+        else
+            # user might have provided their own apt sources.list
+            if ! grep -q backports /etc/apt/sources.list.d/backports.list 2>/dev/null ; then
+                cat >> /etc/apt/sources.list.d/backports.list << EOF
+# debian backports: ${RELEASE}-backports repository:
+deb     http://backports.debian.org/debian-backports ${RELEASE}-backports main
+deb-src http://backports.debian.org/debian-backports ${RELEASE}-backports main
+EOF
+            fi
+        fi
+    fi
+}
+# }}}
+
 # set up kernel-img.conf {{{
 kernelimg_conf() {
   if ! [ -r /etc/kernel-img.conf ] ; then
@@ -107,15 +215,6 @@ EOF
 }
 # }}}
 
-# create default devices {{{
-makedev() {
-  if ! [ -r /dev/hda20 ] ; then
-     echo "Creating generic devices in /dev - this might take a while..."
-     cd /dev && MAKEDEV generic
-  fi
-}
-# }}}
-
 # make sure services do not start up {{{
 install_policy_rcd() {
   if ! [ -r /usr/sbin/policy-rc.d ] ; then
@@ -129,16 +228,41 @@ EOF
 }
 # }}}
 
+# make sure we have an up2date system {{{
+upgrade_system() {
+  if [ "$UPGRADE_SYSTEM" = "yes" ] ; then
+    echo "Running update + upgrade"
+    $APTUPDATE
+    DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTUPGRADE
+  else
+    echo "Not running update + upgrade as \$UPDATE_AND_UPGRADE is not set to 'yes'."
+  fi
+}
+
+# }}}
+# remove now useless apt cache {{{
+remove_apt_cache() {
+  if [ "$RM_APTCACHE" = 'yes' ] ; then
+    echo "Cleaning apt cache."
+    apt-get clean $DPKG_OPTIONS
+  else
+    echo "Not cleaning apt cache as \$RM_APTCACHE is unset."
+  fi
+}
+# }}}
+
 # install additional packages {{{
 packages() {
   # Pre-seed the debconf database with answers. Each question will be marked
   # as seen to prevent debconf from asking the question interactively.
-  [ -f /etc/debootstrap/debconf-selections ] && \
+  [ -f /etc/debootstrap/debconf-selections ] && {
+    echo "Preseeding the debconf database, some lines might be skipped..."
     cat /etc/debootstrap/debconf-selections | debconf-set-selections
+  }
 
   if [ "$PACKAGES" = 'yes' ] ; then
      if ! [ -r /etc/debootstrap/packages ] ; then
-       echo "Error: /etc/debootstrap/packages not found, exiting."
+       echo "Error: /etc/debootstrap/packages (inside chroot) not found, exiting." >&2
        exit 1
      else
        $APTUPDATE
@@ -161,33 +285,55 @@ extrapackages() {
 }
 # }}}
 
-#  sarge specific stuff: mkinitrd {{{
-mkinitrd() {
-  if [ "$RELEASE" = 'sarge' ] ; then
-     sed -i "s#ROOT=probe#ROOT=$TARGET#" /etc/mkinitrd/mkinitrd.conf
+# check if the specified Debian package exists
+package_exists() {
+  output=$(apt-cache show "$1" 2>/dev/null)
+  [ -n "$output" ]
+  return $?
+}
+
+
+# determine the kernel version postfix
+get_kernel_version() {
+  # do not override $KERNEL if set via config file
+  if [ -n "$KERNEL" ] ; then
+    echo "$KERNEL"
+    return 0
   fi
+
+  case $ARCH in
+    i386)   KARCH=686   ;;
+    amd64)  KARCH=amd64 ;;
+    *)
+      echo "Only i386 and amd64 are currently supported" >&2
+      return 1
+  esac
+
+  for KPREFIX in "" "2.6-" ; do  # iterate through the kernel prefixes,
+                                 # currently "" and "2.6-"
+    if package_exists linux-image-${KPREFIX}${KARCH} ; then
+      echo ${KPREFIX}${KARCH}
+      return 0
+    fi
+
+  done
 }
-# }}}
 
 # install kernel packages {{{
 kernel() {
-  # do not override $KERNEL if set via config file
-  if [ -z "$KERNEL" ] ; then
-     if [ "$ARCH" = 'i386' ] ; then
-        KERNEL='2.6-686'
-     elif [ "$ARCH" = 'amd64' ] ; then
-        KERNEL='2.6-amd64'
-     fi
+  if [ -n "$NOKERNEL" ] ; then
+    echo "Skipping installation of kernel packages as requested via --nokernel"
+    return 0
   fi
 
-  if [ -n "$KERNEL" ] ; then
-     $APTUPDATE
-     if [ "$RELEASE" = 'sarge' ] ; then
-        KERNELPACKAGES="kernel-image-$KERNEL kernel-headers-$KERNEL"
-     else
-        KERNELPACKAGES="linux-image-$KERNEL linux-headers-$KERNEL"
-     fi
-      DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL $KERNELPACKAGES
+  $APTUPDATE
+  KVER=$(get_kernel_version)
+  if [ -n "$KVER" ] ; then
+     # note: install busybox to be able to debug initramfs
+     KERNELPACKAGES="linux-image-$KVER linux-headers-$KVER busybox firmware-linux-free firmware-linux"
+     DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL $KERNELPACKAGES
+  else
+     echo "Warning: Could not find a kernel for your system. Your system won't be able to boot itself!"
   fi
 }
 # }}}
@@ -196,9 +342,10 @@ kernel() {
 reconfigure() {
   if [ -n "$RECONFIGURE" ] ; then
      for package in $RECONFIGURE ; do
-         dpkg --list $package 1>/dev/null 2>/dev/null && \
-         DEBIAN_FRONTEND=$DEBIAN_FRONTEND dpkg-reconfigure $package || \
-         echo "Warning: $package does not exist, can not reconfigure it."
+         if dpkg --list $package >/dev/null 2>&1 | grep -q '^ii' ; then
+           DEBIAN_FRONTEND=$DEBIAN_FRONTEND dpkg-reconfigure $package || \
+           echo "Warning: $package does not exist, can not reconfigure it."
+         fi
      done
   fi
 }
@@ -207,11 +354,21 @@ reconfigure() {
 # set password of user root {{{
 passwords()
 {
+  if [ -n "$NOPASSWORD" ] ; then
+    echo "Skip setting root password as requested."
+    return 0
+  fi
+
   echo "Activating shadow passwords."
   shadowconfig on
 
+  CHPASSWD_OPTION=
+  if chpasswd --help 2>&1 | grep -q -- '-m,' ; then
+     CHPASSWD_OPTION='-m'
+  fi
+
   if [ -n "$ROOTPASSWORD" ] ; then
-     echo root:"$ROOTPASSWORD" | chpasswd -m
+     echo root:"$ROOTPASSWORD" | chpasswd $CHPASSWD_OPTION
      export ROOTPASSWORD=''
   else
     a='1'
@@ -219,17 +376,21 @@ passwords()
      echo "Setting password for user root:"
      while [ "$a" != "$b" ] ; do
        echo -n "Enter new UNIX password for user root: "
-       read -s a
+       askpass
+       a="$resp"
+       unset resp
        echo
        echo -n "Retype new UNIX password for user root: "
-       read -s b
+       askpass
+       b="$resp"
+       unset resp
        echo
        if [ "$a" != "$b" ] ; then
          echo "Sorry, passwords do not match. Retry."
          a='1'
          b='2'
        else
-         echo root:"$a" | chpasswd -m
+         echo root:"$a" | chpasswd $CHPASSWD_OPTION
          unset a
          unset b
        fi
@@ -240,28 +401,39 @@ passwords()
 
 # set up /etc/hosts {{{
 hosts() {
-  if ! [ -f /etc/hosts ] ; then
-     echo "Setting up /etc/hosts"
-     echo "127.0.0.1       localhost  $HOSTNAME" > /etc/hosts
+  if [ -f /etc/hosts ] ; then
+     sed -i "s#127.0.0.1 .*#127.0.0.1       localhost  $HOSTNAME#" /etc/hosts
+     [ -n "$HOSTNAME" ] && sed -i "s/grml/$HOSTNAME/g" /etc/hosts
+  else
+     cat > /etc/hosts << EOF
+127.0.0.1       localhost $HOSTNAME
+
+#127.0.0.1       localhost
+#127.0.1.1       $HOSTNAME.example.org $HOSTNAME
+
+# The following lines are desirable for IPv6 capable hosts
+#::1     ip6-localhost ip6-loopback $HOSTNAME
+::1     ip6-localhost ip6-loopback
+fe00::0 ip6-localnet
+ff00::0 ip6-mcastprefix
+ff02::1 ip6-allnodes
+ff02::2 ip6-allrouters
+ff02::3 ip6-allhosts
+EOF
   fi
 }
 # }}}
 
-# set up /etc/network/interfaces {{{
-interfaces() {
-  if ! [ -r /etc/network/interfaces ] ; then
-     echo "Setting up /etc/network/interfaces"
-     cat >> /etc/network/interfaces << EOF
-
-# loopback device:
-iface lo inet loopback
-auto lo
-
-# eth0:
-# iface eth0 inet dhcp
-# auto eth0
+# set default locales {{{
+default_locales() {
+  if [ -n "$DEFAULT_LOCALES" ] ; then
+    if ! [ -x /usr/sbin/update-locale ] ; then
+      echo "Warning: update-locale executable not available (no locales package installed?)"
+      echo "Ignoring request to run update-locale for $DEFAULT_LOCALES therefore"
+      return 0
+    fi
 
-EOF
+    /usr/sbin/update-locale LANGUAGE="$DEFAULT_LANGUAGE" LANG="$DEFAULT_LOCALES"
   fi
 }
 # }}}
@@ -286,14 +458,14 @@ fi
 
 cat >> /etc/fstab << EOF
 proc           /proc        proc    defaults                      0   0
-/sys           /sys         sysfs   noauto,rw,nosuid,nodev,noexec 0   0
 /dev/cdrom     /mnt/cdrom0  iso9660 ro,user,noauto                0   0
 # some other examples:
-# /dev/sda2       none         swap    sw                   0   0
+# /dev/sda2       none         swap    sw,pri=0             0   0
 # /dev/hda1       /Grml        ext3    dev,suid,user,noauto 0  2
-# //1.2.3.4/pub   /smb/pub     smbfs   defaults,user,noauto,uid=grml,gid=grml 0 0
+# //1.2.3.4/pub   /smb/pub     cifs    user,noauto,uid=grml,gid=grml 0 0
 # linux:/pub      /beer        nfs     defaults             0  0
 # tmpfs           /tmp         tmpfs   size=300M            0  0
+# /dev/sda5       none         swap    sw                   0  0
 EOF
 }
 # }}}
@@ -317,6 +489,30 @@ hostname() {
   if [ -n "$HOSTNAME" ] ; then
      echo "Setting hostname to ${HOSTNAME}."
      echo "$HOSTNAME" > /etc/hostname
+
+     # adjust postfix configuration
+     if [ -r /etc/postfix/main.cf ] ; then
+        # adjust hostname related options:
+        sed -i "s/grml/$HOSTNAME/g" /etc/postfix/main.cf
+
+        # listen on loopback interface only:
+        sed -i "s/^inet_interfaces = .*/inet_interfaces = loopback-only/" /etc/postfix/main.cf
+        grep -q inet_interfaces /etc/postfix/main.cf || echo 'inet_interfaces = loopback-only' >> /etc/postfix/main.cf
+     fi
+     if [ -r /etc/mailname ] ; then
+        # adjust /etc/mailname
+        local etc_mail_domain=$(/bin/dnsdomainname 2>/dev/null || echo localdomain)
+        case "$HOSTNAME" in
+          *.*)
+            local mailname="$HOSTNAME"
+            ;;
+          *)
+            local mailname="${HOSTNAME}.${etc_mail_domain}"
+            ;;
+        esac
+        echo "Setting mailname to ${mailname}"
+        echo "$mailname" > /etc/mailname
+     fi
   fi
 }
 # }}}
@@ -324,60 +520,75 @@ hostname() {
 # generate initrd/initramfs {{{
 initrd() {
   # assume the first available kernel as our main kernel
-  KERNELIMG=$(ls -1 /boot/vmlinuz-* | head -1)
+  KERNELIMG=$(ls -1 /boot/vmlinuz-* 2>/dev/null | head -1)
+  if [ -z "$KERNELIMG" ] ; then
+     echo 'No kernel image found, skipping initrd stuff.'>&2
+     return
+  fi
+
   KERNELVER=${KERNELIMG#/boot/vmlinuz-}
 
   # generate initrd
   if [ -n "$INITRD" ] ; then
-     if [ "$RELEASE" = 'sarge' ] ; then
-        echo "Release sarge detected, will not create an initrd."
-     else
-        echo "Generating initrd."
-        update-initramfs -c -t -k $KERNELVER
-        if [ -f "/boot/initrd.img-$KERNELVER" ] ; then
-           GRUBINITRD="initrd          /boot/initrd.img-$KERNELVER"
-           LILOINITRD="        initrd=/boot/initrd.img-$KERNELVER"
-        fi
-     fi
+     echo "Generating initrd."
+     update-initramfs -c -t -k $KERNELVER
   fi
 }
 # }}}
 
 # grub configuration/installation {{{
-grub() {
-  if [ -z "$GROOT" ] ; then
-     echo "Warning: \$GROOT is not defined, will not adjust grub configuration therefore."
+grub_install() {
+
+  if [ -z "$GRUB" ] ; then
+    echo "Notice: \$GRUB not defined, will not install grub inside chroot at this stage."
+    return 0
+  fi
+
+  if ! dpkg --list grub-pc 2>/dev/null | grep -q '^ii' ; then
+    echo "Notice: grub option set but no grub-pc package, installing it therefore."
+    DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL grub-pc
+  fi
+
+  if ! [ -x "$(which grub-install)" ] ; then
+     echo "Error: grub-install not available. (Error while installing grub package?)" >&2
+     return 1
+  fi
+
+  if [ -n "$SELECTED_PARTITIONS" ] ; then # using sw-raid
+     for device in $SELECTED_PARTITIONS ; do
+        GRUB="${device%%[0-9]}"
+        echo "Installing grub on ${GRUB}:"
+        grub-install --no-floppy "$GRUB"
+     done
   else
-     echo "Adjusting grub configuration for use on ${GROOT}."
-
-     # copy stage-files to /boot/grub/
-     [ -d /boot/grub/ ] || mkdir /boot/grub
-     # i386 specific:
-     [ -d /usr/lib/grub/i386-pc ]   && cp /usr/lib/grub/i386-pc/* /boot/grub/
-     # amd64 specific:
-     [ -d /usr/lib/grub/x86_64-pc ] && cp /usr/lib/grub/x86_64-pc/* /boot/grub/
-     # sarge ships grub files in another directory
-     [ "$RELEASE" = 'sarge' ]       && cp /lib/grub/i386-pc/* /boot/grub/
-
-     # finally install grub
-     if [ -x /usr/sbin/update-grub ] ; then
-        UPDATEGRUB='/usr/sbin/update-grub'
-     else
-        UPDATEGRUB='/sbin/update-grub'
-     fi
-     $UPDATEGRUB -y
-     if [ -f /boot/grub/menu.lst ] ; then
-        sed -i "s/^# groot=.*/# groot=(${GROOT})/g" /boot/grub/menu.lst
-       if [ -n "$TARGET_UUID" ] ; then
-          sed -i "s|^# kopt=root=.*|# kopt=root=UUID=${TARGET_UUID} ro ${BOOT_APPEND}|g" /boot/grub/menu.lst
-       else
-          sed -i "s|^# kopt=root=.*|# kopt=root=${TARGET} ro ${BOOT_APPEND}|g" /boot/grub/menu.lst
-       fi
-        # not sure why savedefault does not work for me; any ideas?
-        sed -i "s/^savedefault.*/# &/g" /boot/grub/menu.lst
-        $UPDATEGRUB -y
-     fi
+     echo "Installing grub on ${GRUB}:"
+     grub-install --no-floppy "$GRUB"
   fi
+
+  echo "Adjusting grub configuration for use on ${GRUB}."
+
+  # finally install grub
+  if [ -x /usr/sbin/update-grub ] ; then
+     UPDATEGRUB='/usr/sbin/update-grub'
+  elif [ -x /sbin/update-grub ] ; then
+     UPDATEGRUB='/sbin/update-grub'
+  else
+    echo "Error: update-grub not available, can not execute it." >&2
+    return 1
+  fi
+
+  $UPDATEGRUB
+}
+# }}}
+
+# execute all scripts present in /etc/debootstrap/chroot-scripts/ {{{
+custom_scripts() {
+  [ -d /etc/debootstrap/chroot-scripts/ ] || return 0
+
+  for script in /etc/debootstrap/chroot-scripts/* ; do
+      echo "Executing script $script"
+      $script && echo "done" || echo "failed"
+  done
 }
 # }}}
 
@@ -385,32 +596,51 @@ grub() {
 services() {
   for service in ssh mdadm mdadm-raid ; do
     if [ -x /etc/init.d/"$service" ] ; then
-       /etc/init.d/"$service" stop || /bin/true
+       /etc/init.d/"$service" stop || true
     fi
   done
 }
 # }}}
 
-# unmount all filesystems in chroot, make sure nothing is left {{{
+# unmount /proc and make sure nothing is left {{{
 finalize() {
   # make sure we don't leave any sensible data
   rm -f /etc/debootstrap/variables
+
   [ -n "$POLICYRCD" ] && rm -f /usr/sbin/policy-rc.d
-  umount -a    1>/dev/null 2>/dev/null || true
-  umount /proc 1>/dev/null 2>/dev/null || true
-  umount /proc 1>/dev/null 2>/dev/null || true
-  umount -a    1>/dev/null 2>/dev/null || true
+
+  umount /proc >/dev/null 2>/dev/null || true
+}
+# }}}
+
+# signal handler {{{
+signal_handler() {
+  finalize
+  [ -n "$1" ] && EXIT="$1" || EXIT="1"
+  exit "$EXIT"
 }
 # }}}
 
+# set signal handler {{{
+trap signal_handler HUP INT QUIT TERM
+# }}}
+
 # execute the functions {{{
- for i in chrootmirror grmlrepos kernelimg_conf makedev install_policy_rcd \
-     packages extrapackages mkinitrd kernel reconfigure hosts interfaces   \
-     timezone fstab hostname initrd grub passwords services finalize ; do
-    if stage $i ; then
+
+ # always execute install_policy_rcd
+ install_policy_rcd
+
+ for i in chrootmirror grmlrepos backportrepos kernelimg_conf \
+     kernel packages extrapackages reconfigure hosts \
+     default_locales timezone fstab hostname initrd grub_install passwords \
+     custom_scripts upgrade_system remove_apt_cache services \
+     remove_chrootmirror; do
+     if stage $i ; then
        $i && stage $i done || exit 1
-    fi
+     fi
   done
+  # always execute the finalize stage:
+  finalize
 # }}}
 
 # finally exit the chroot {{{